"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const random_generator_1 = require("../../expressions/random-generator");
const _1 = require("./");
class CommonWithAttributes extends _1.Chaining {
    constructor(attributes, currentStack) {
        super('withAttributes', currentStack);
        this._withAttributes = this.generateExpressionAttributeNames(attributes);
        this._stack.push(this);
    }
    generateExpressionAttributeNames(attrs) {
        const attributes = new Array();
        const expressionAttributeNames = attrs.reduce((acc, value) => {
            const randomId = '#' + random_generator_1.randomGenerator();
            acc[randomId] = value;
            attributes.push(randomId);
            return acc;
        }, {});
        return { attributes, expressionAttributeNames };
    }
}
exports.CommonWithAttributes = CommonWithAttributes;
