import { DeleteResult } from '../../../database-operations/delete';
import Expression from '../../../expressions/expression';
import { EntitySchema } from '../../../schema';
import { Chaining } from '../../common';
import { DeleteChainingKind } from './';
import { DynamoDeleteWithCondition } from './with-condition';
export declare type DeleteType = 'delete';
export interface Delete<Entity, KeySchema> {
    schema: EntitySchema;
    key: KeySchema;
}
export declare class DynamoDelete<Entity, KeySchema> extends Chaining<DeleteChainingKind> {
    protected _delete: Delete<Entity, KeySchema>;
    constructor(deleteMetadata: Delete<Entity, KeySchema>);
    withCondition(expression: Expression): DynamoDeleteWithCondition<Entity, KeySchema>;
    execute(): Promise<DeleteResult<Entity>>;
}
