"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("../../common");
const execute_1 = require("./execute");
const with_condition_1 = require("./with-condition");
class DynamoDelete extends common_1.Chaining {
    constructor(deleteMetadata) {
        super('delete');
        this._delete = deleteMetadata;
        this._stack.push(this);
    }
    withCondition(expression) {
        return new with_condition_1.DynamoDeleteWithCondition({ expression }, this._stack);
    }
    execute() {
        return execute_1.execute(this._stack);
    }
}
exports.DynamoDelete = DynamoDelete;
