"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const delete_1 = require("../../../database-operations/delete");
function extractFromStack(stack) {
    const deleteMetadata = stack[0]._delete;
    let withCondition;
    for (const current of stack) {
        switch (current._kind) {
            case 'withCondition': withCondition = current._withCondition;
        }
    }
    return { deleteMetadata, withCondition };
}
function execute(stack) {
    const { deleteMetadata, withCondition } = extractFromStack(stack);
    const deleteInput = delete_1.buildDeleteInput(deleteMetadata, withCondition);
    return delete_1.deleteItem(deleteInput, deleteMetadata.schema.dynamoPromise);
}
exports.execute = execute;
