import { BatchGetResult } from '../../../database-operations/batch-get';
import { EntitySchema } from '../../../schema';
import { Chaining } from '../../common';
import { BatchGetChainingKind } from './';
import { DynamoGetWithAttributes } from './with-attributes';
export declare type BatchGetType = 'batchGet';
export interface BatchGet<KeySchema> {
    schema: EntitySchema;
    keys: KeySchema[];
}
export declare class DynamoBatchGet<Entity, KeySchema> extends Chaining<BatchGetChainingKind> {
    protected _batchGet: BatchGet<KeySchema>;
    constructor(batchGet: BatchGet<KeySchema>);
    withAttributes<K extends keyof Entity>(attributes: K[]): DynamoGetWithAttributes<Pick<Entity, K>, KeySchema>;
    execute(): Promise<BatchGetResult<Entity, KeySchema>>;
}
