"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const batch_get_1 = require("../../../database-operations/batch-get");
function extractFromStack(stack) {
    const batchGetMetadata = stack[0]._batchGet;
    let withAttributes;
    for (const current of stack) {
        switch (current._kind) {
            case 'withAttributes': withAttributes = current._withAttributes;
        }
    }
    return { batchGetMetadata, withAttributes };
}
function execute(stack) {
    const { batchGetMetadata, withAttributes } = extractFromStack(stack);
    const batchGetInput = batch_get_1.buildBatchGetInput(batchGetMetadata, withAttributes);
    return batch_get_1.batchGet(batchGetMetadata.schema.tableName, batchGetInput, batchGetMetadata.schema.dynamoPromise);
}
exports.execute = execute;
