"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const get_1 = require("../../../database-operations/get");
function extractFromStack(stack) {
    const getMetadata = stack[0]._get;
    let withAttributes;
    for (const current of stack) {
        switch (current._kind) {
            case 'withAttributes': withAttributes = current._withAttributes;
        }
    }
    return { getMetadata, withAttributes };
}
function execute(stack) {
    const { getMetadata, withAttributes } = extractFromStack(stack);
    const getInput = get_1.buildGetInput(getMetadata, withAttributes);
    return get_1.get(getInput, getMetadata.schema.dynamoPromise);
}
exports.execute = execute;
