import { GetResult } from '../../../database-operations/get';
import { EntitySchema } from '../../../schema';
import { Chaining } from '../../common';
import { GetChainingKind } from './';
import { DynamoGetWithAttributes } from './with-attributes';
export declare type GetType = 'get';
export interface Get<KeySchema> {
    schema: EntitySchema;
    key: KeySchema;
}
export declare class DynamoGet<Entity, KeySchema> extends Chaining<GetChainingKind> {
    protected _get: Get<KeySchema>;
    constructor(get: Get<KeySchema>);
    withAttributes<K extends keyof Entity>(attributes: K[]): DynamoGetWithAttributes<Pick<Entity, K>, KeySchema>;
    execute(): Promise<GetResult<Entity, KeySchema>>;
}
