"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("../../common");
const execute_1 = require("./execute");
const with_attributes_1 = require("./with-attributes");
class DynamoGet extends common_1.Chaining {
    constructor(get) {
        super('get');
        this._get = get;
        this._stack.push(this);
    }
    withAttributes(attributes) {
        return new with_attributes_1.DynamoGetWithAttributes(attributes, this._stack);
    }
    execute() {
        return execute_1.execute(this._stack);
    }
}
exports.DynamoGet = DynamoGet;
