"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const query_1 = require("../../../database-operations/query");
function extractFromStack(stack) {
    const query = (stack[0]._query);
    let withSortKeyCondition;
    let filter;
    let withAttributes;
    let withOptions;
    let paginate;
    for (const current of stack) {
        switch (current._kind) {
            case 'withSortKeyCondition': withSortKeyCondition = current._withSortKeyCondition;
            case 'filter': filter = current._filter;
            case 'withAttributes': withAttributes = current._withAttributes;
            case 'withOptions': withOptions = current._withOptions;
            case 'paginate': paginate = current._paginate;
        }
    }
    return { query, filter, withAttributes, paginate, withSortKeyCondition, withOptions };
}
function executeAllResults(stack) {
    const { query, filter, withSortKeyCondition, withAttributes, withOptions } = extractFromStack(stack);
    const queryInput = query_1.buildQueryInput(query, withSortKeyCondition, filter, withAttributes, withOptions);
    return query_1.queryAllResults(queryInput, query.schema.dynamoPromise);
}
exports.executeAllResults = executeAllResults;
function executePaginate(stack) {
    const { query, filter, withSortKeyCondition, withAttributes, withOptions, paginate } = extractFromStack(stack);
    const queryInput = query_1.buildQueryInput(query, withSortKeyCondition, filter, withAttributes, withOptions, paginate);
    return query_1.queryPaginate(queryInput, query.schema.dynamoPromise);
}
exports.executePaginate = executePaginate;
