import { Chaining, CommonFilter, Filter } from '../../common';
import { QueryChainingKind } from './';
import { DynamoQueryAllResults } from './all-results';
import { DynamoQueryPaginate } from './paginate';
import { DynamoQueryWithAttributes } from './with-attributes';
import { DynamoQueryWithOptions, WithOptions } from './with-options';
export declare class DynamoQueryFilter<Entity, KeySchema> extends CommonFilter<QueryChainingKind> {
    constructor(filter: Filter, currentStack: Array<Chaining<QueryChainingKind>>);
    withAttributes<K extends keyof Entity>(attributes: K[]): DynamoQueryWithAttributes<Pick<Entity, K>, KeySchema>;
    withOptions(options: WithOptions): DynamoQueryWithOptions<Entity, KeySchema>;
    paginate(limit?: number, lastKey?: KeySchema): DynamoQueryPaginate<Entity, KeySchema>;
    allResults(): DynamoQueryAllResults<Entity, KeySchema>;
}
