"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("../../common");
const all_results_1 = require("./all-results");
const paginate_1 = require("./paginate");
const with_options_1 = require("./with-options");
class DynamoQueryWithAttributes extends common_1.CommonWithAttributes {
    constructor(attributes, currentStack) {
        super(attributes, currentStack);
    }
    withOptions(options) {
        return new with_options_1.DynamoQueryWithOptions(this._stack, options);
    }
    paginate(limit, lastKey) {
        return new paginate_1.DynamoQueryPaginate(this._stack, { limit, lastKey });
    }
    allResults() {
        return new all_results_1.DynamoQueryAllResults(this._stack);
    }
}
exports.DynamoQueryWithAttributes = DynamoQueryWithAttributes;
