import { Chaining } from '../../common';
import { QueryChainingKind } from './';
import { DynamoQueryAllResults } from './all-results';
import { DynamoQueryPaginate } from './paginate';
export declare type WithOptionsType = 'withOptions';
export interface WithOptions {
    order?: 'ascending' | 'descending';
}
export declare class DynamoQueryWithOptions<Entity, KeySchema> extends Chaining<QueryChainingKind> {
    private _withOptions;
    constructor(currentStack: Array<Chaining<QueryChainingKind>>, withOptions: WithOptions);
    paginate(limit?: number, lastKey?: KeySchema): DynamoQueryPaginate<Entity, KeySchema>;
    allResults(): DynamoQueryAllResults<Entity, KeySchema>;
}
