"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("../../common");
const all_results_1 = require("./all-results");
const paginate_1 = require("./paginate");
class DynamoQueryWithOptions extends common_1.Chaining {
    constructor(currentStack, withOptions) {
        super('withOptions', currentStack);
        this._withOptions = withOptions;
        this._stack.push(this);
    }
    paginate(limit, lastKey) {
        return new paginate_1.DynamoQueryPaginate(this._stack, { limit, lastKey });
    }
    allResults() {
        return new all_results_1.DynamoQueryAllResults(this._stack);
    }
}
exports.DynamoQueryWithOptions = DynamoQueryWithOptions;
