"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const scan_1 = require("../../../database-operations/scan");
function extractFromStack(stack) {
    const schema = stack[0]._schema;
    let filter;
    let withAttributes;
    let paginate;
    for (const current of stack) {
        switch (current._kind) {
            case 'filter': filter = current._filter;
            case 'withAttributes': withAttributes = current._withAttributes;
            case 'paginate': paginate = current._paginate;
        }
    }
    return { schema, filter, withAttributes, paginate };
}
function executeAllResults(stack) {
    const { schema, filter, withAttributes } = extractFromStack(stack);
    const scanInput = scan_1.buildScanInput(schema, filter, withAttributes);
    return scan_1.scanAllResults(scanInput, schema.dynamoPromise);
}
exports.executeAllResults = executeAllResults;
function executePaginate(stack) {
    const { schema, filter, withAttributes, paginate } = extractFromStack(stack);
    const scanInput = scan_1.buildScanInput(schema, filter, withAttributes, paginate);
    return scan_1.scanPaginate(scanInput, schema.dynamoPromise);
}
exports.executePaginate = executePaginate;
