import { Chaining, CommonFilter, Filter } from '../../common';
import { ScanChainingKind } from './';
import { DynamoScanAllResults } from './all-results';
import { DynamoScanPaginate } from './paginate';
import { DynamoScanWithAttributes } from './with-attributes';
export declare class DynamoScanFilter<Entity, KeySchema> extends CommonFilter<ScanChainingKind> {
    constructor(filter: Filter, currentStack: Array<Chaining<ScanChainingKind>>);
    withAttributes<K extends keyof Entity>(attributes: K[]): DynamoScanWithAttributes<Pick<Entity, K>, KeySchema>;
    paginate(limit?: number, lastKey?: KeySchema): DynamoScanPaginate<Entity, KeySchema>;
    allResults(): DynamoScanAllResults<Entity, KeySchema>;
}
