"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("../../common");
const all_results_1 = require("./all-results");
const paginate_1 = require("./paginate");
const with_attributes_1 = require("./with-attributes");
class DynamoScanFilter extends common_1.CommonFilter {
    constructor(filter, currentStack) {
        super(filter, currentStack);
    }
    withAttributes(attributes) {
        return new with_attributes_1.DynamoScanWithAttributes(attributes, this._stack);
    }
    paginate(limit, lastKey) {
        return new paginate_1.DynamoScanPaginate(this._stack, { limit, lastKey });
    }
    allResults() {
        return new all_results_1.DynamoScanAllResults(this._stack);
    }
}
exports.DynamoScanFilter = DynamoScanFilter;
