import Expression from '../../../expressions/expression';
import { EntitySchema } from '../../../schema';
import { Chaining } from '../../common';
import { ScanChainingKind } from './';
import { DynamoScanAllResults } from './all-results';
import { DynamoScanFilter } from './filter';
import { DynamoScanPaginate } from './paginate';
import { DynamoScanWithAttributes } from './with-attributes';
export declare type ScanType = 'scan';
export declare class DynamoScan<Entity, KeySchema> extends Chaining<ScanChainingKind> {
    protected _schema: EntitySchema;
    constructor(schema: EntitySchema);
    filter(filterExpression: Expression): DynamoScanFilter<Entity, KeySchema>;
    withAttributes<K extends keyof Entity>(attributes: K[]): DynamoScanWithAttributes<Pick<Entity, K>, KeySchema>;
    paginate(limit?: number, lastKey?: KeySchema): DynamoScanPaginate<Entity, KeySchema>;
    allResults(): DynamoScanAllResults<Entity, KeySchema>;
}
