"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("../../common");
const all_results_1 = require("./all-results");
const filter_1 = require("./filter");
const paginate_1 = require("./paginate");
const with_attributes_1 = require("./with-attributes");
class DynamoScan extends common_1.Chaining {
    constructor(schema) {
        super('scan');
        this._schema = schema;
        this._stack.push(this);
    }
    filter(filterExpression) {
        return new filter_1.DynamoScanFilter({ filterExpression }, this._stack);
    }
    withAttributes(attributes) {
        return new with_attributes_1.DynamoScanWithAttributes(attributes, this._stack);
    }
    paginate(limit, lastKey) {
        return new paginate_1.DynamoScanPaginate(this._stack, { limit, lastKey });
    }
    allResults() {
        return new all_results_1.DynamoScanAllResults(this._stack);
    }
}
exports.DynamoScan = DynamoScan;
