import { BatchWriteResult } from '../../../database-operations/batch-write';
import { EntitySchema } from '../../../schema';
import { Chaining } from '../../common';
import { BatchWriteChainingKind } from './';
export declare type BatchWriteType = 'batchWrite';
export interface BatchWrite<Table> {
    schema: EntitySchema;
    items: Table[];
}
export declare class DynamoBatchWrite<Entity> extends Chaining<BatchWriteChainingKind> {
    protected _batchWrite: BatchWrite<Entity>;
    constructor(batchWrite: BatchWrite<Entity>);
    execute(): Promise<BatchWriteResult<Entity>>;
}
