"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const put_1 = require("../../../database-operations/put");
function extractFromStack(stack) {
    const putMetadata = stack[0]._put;
    let withCondition;
    for (const current of stack) {
        switch (current._kind) {
            case 'withCondition': withCondition = current._withCondition;
        }
    }
    return { putMetadata, withCondition };
}
function execute(stack) {
    const { putMetadata, withCondition } = extractFromStack(stack);
    const putInput = put_1.buildPutInput(putMetadata, withCondition);
    return put_1.put(putMetadata.item, putInput, putMetadata.schema.dynamoPromise);
}
exports.execute = execute;
