import { PutResult } from '../../../database-operations/put';
import Expression from '../../../expressions/expression';
import { EntitySchema } from '../../../schema';
import { Chaining } from '../../common';
import { PutChainingKind } from './';
import { DynamoPutWithCondition } from './with-condition';
export declare type PutType = 'put';
export interface Put<Entity> {
    schema: EntitySchema;
    item: Entity;
}
export declare class DynamoPut<Entity> extends Chaining<PutChainingKind> {
    protected _put: Put<Entity>;
    constructor(put: Put<Entity>);
    withCondition(expression: Expression): DynamoPutWithCondition<Entity>;
    execute(): Promise<PutResult<Entity>>;
}
