"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("../../common");
const execute_1 = require("./execute");
const with_condition_1 = require("./with-condition");
class DynamoPut extends common_1.Chaining {
    constructor(put) {
        super('put');
        this._put = put;
        this._stack.push(this);
    }
    withCondition(expression) {
        return new with_condition_1.DynamoPutWithCondition({ expression }, this._stack);
    }
    execute() {
        return execute_1.execute(this._stack);
    }
}
exports.DynamoPut = DynamoPut;
