"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const update_1 = require("../../database-operations/update");
function extractFromStack(stack) {
    const updateMetadata = stack[0]._update;
    let withCondition;
    for (const current of stack) {
        switch (current._kind) {
            case 'withCondition': withCondition = current._withCondition;
        }
    }
    return { updateMetadata, withCondition };
}
function execute(stack) {
    const { updateMetadata, withCondition } = extractFromStack(stack);
    const updateInput = update_1.buildUpdateInput(updateMetadata, withCondition);
    return update_1.update(updateInput, updateMetadata.schema.dynamoPromise);
}
exports.execute = execute;
