"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const helpers_1 = require("../helpers");
function buildBatchGetInput(batchGet, withAttributes) {
    const input = {
        RequestItems: {
            [batchGet.schema.tableName]: {
                Keys: batchGet.keys.map((key) => helpers_1.buildKey(key)),
            },
        },
    };
    if (withAttributes) {
        input.RequestItems[batchGet.schema.tableName]
            .ProjectionExpression = helpers_1.projectionExpression(withAttributes.attributes);
        input.RequestItems[batchGet.schema.tableName]
            .ExpressionAttributeNames = withAttributes.expressionAttributeNames;
    }
    return input;
}
exports.buildBatchGetInput = buildBatchGetInput;
