"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const resolve_expression_1 = require("../../expressions/resolve-expression");
const helpers_1 = require("../helpers");
function buildDeleteInput(deleteMetadata, withCondition) {
    const input = {
        TableName: deleteMetadata.schema.tableName,
        Key: helpers_1.buildKey(deleteMetadata.key),
        ReturnValues: 'ALL_OLD',
    };
    if (withCondition) {
        const expression = resolve_expression_1.resolveExpression(withCondition.expression.stack);
        input.ConditionExpression = expression.resolvedExpression;
        input.ExpressionAttributeNames = helpers_1.mergeExpressionAttributeNames(expression.expressionAttributeNames);
        input.ExpressionAttributeValues = helpers_1.mergeExpressionAttributeValues(expression.expressionAttributeValues);
    }
    return input;
}
exports.buildDeleteInput = buildDeleteInput;
