"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const marshalItem = require('dynamodb-marshaler').marshalItem;
const resolve_expression_1 = require("../../expressions/resolve-expression");
const helpers_1 = require("../helpers");
function buildPutInput(put, conditionalExpression) {
    const input = {
        TableName: put.schema.tableName,
        Item: marshalItem(put.item),
    };
    if (conditionalExpression) {
        const expression = resolve_expression_1.resolveExpression(conditionalExpression.expression.stack);
        input.ConditionExpression = expression.resolvedExpression;
        input.ExpressionAttributeNames = helpers_1.mergeExpressionAttributeNames(expression.expressionAttributeNames);
        input.ExpressionAttributeValues = helpers_1.mergeExpressionAttributeValues(expression.expressionAttributeValues);
    }
    return input;
}
exports.buildPutInput = buildPutInput;
