import { DynamoDB } from 'aws-sdk';
import { Omit } from '../../helpers';
import DynamoToPromise from '../dynamo-to-promise';
export interface QueryResult<TableModel, KeySchema> {
    data: TableModel[];
    lastKey?: KeySchema;
}
export declare function queryPaginate<Entity, KeySchema>(queryInput: DynamoDB.QueryInput, dynamoPromise: DynamoToPromise): Promise<QueryResult<Entity, KeySchema>>;
export declare function queryAllResults<Entity, KeySchema>(queryInput: DynamoDB.QueryInput, dynamoPromise: DynamoToPromise): Promise<Omit<QueryResult<Entity, KeySchema>, 'lastKey'>>;
