"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const helpers_1 = require("../helpers");
function queryPaginate(queryInput, dynamoPromise) {
    return __awaiter(this, void 0, void 0, function* () {
        const queryOutput = yield dynamoPromise.query(queryInput);
        const result = {
            data: queryOutput.Items,
            lastKey: queryOutput.LastEvaluatedKey,
        };
        return result;
    });
}
exports.queryPaginate = queryPaginate;
function queryAllResults(queryInput, dynamoPromise) {
    return __awaiter(this, void 0, void 0, function* () {
        let lastKey;
        const result = {};
        do {
            const queryOutput = yield dynamoPromise.query(queryInput);
            if (!result.data) {
                result.data = new Array();
            }
            result.data = result.data.concat(queryOutput.Items);
            lastKey = queryOutput.LastEvaluatedKey;
            if (lastKey) {
                queryInput.ExclusiveStartKey = helpers_1.buildExclusiveStartKey(lastKey);
            }
        } while (lastKey);
        return result;
    });
}
exports.queryAllResults = queryAllResults;
