import { DynamoDB } from 'aws-sdk';
import { Omit } from '../../helpers';
import DynamoToPromise from '../dynamo-to-promise';
export interface ScanResult<TableModel, KeySchema> {
    data: TableModel[];
    lastKey?: KeySchema;
}
export declare function scanPaginate<Entity, KeySchema>(scanInput: DynamoDB.ScanInput, dynamoPromise: DynamoToPromise): Promise<ScanResult<Entity, KeySchema>>;
export declare function scanAllResults<Entity, KeySchema>(scanInput: DynamoDB.ScanInput, dynamoPromise: DynamoToPromise): Promise<Omit<ScanResult<Entity, KeySchema>, 'lastKey'>>;
