"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const helpers_1 = require("../helpers");
function scanPaginate(scanInput, dynamoPromise) {
    return __awaiter(this, void 0, void 0, function* () {
        const scanOutput = yield dynamoPromise.scan(scanInput);
        const result = {
            data: scanOutput.Items,
            lastKey: scanOutput.LastEvaluatedKey,
        };
        return result;
    });
}
exports.scanPaginate = scanPaginate;
function scanAllResults(scanInput, dynamoPromise) {
    return __awaiter(this, void 0, void 0, function* () {
        let lastKey;
        const result = {};
        do {
            const scanOutput = yield dynamoPromise.scan(scanInput);
            if (!result.data) {
                result.data = new Array();
            }
            result.data = result.data.concat(scanOutput.Items);
            lastKey = scanOutput.LastEvaluatedKey;
            if (lastKey) {
                scanInput.ExclusiveStartKey = helpers_1.buildExclusiveStartKey(lastKey);
            }
        } while (lastKey);
        return result;
    });
}
exports.scanAllResults = scanAllResults;
