"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const marshalItem = require('dynamodb-marshaler').marshalItem;
const resolve_expression_1 = require("../../expressions/resolve-expression");
const helpers_1 = require("../helpers");
function buildUpdateInput(update, conditionalExpression) {
    const input = {
        TableName: update.schema.tableName,
        Key: marshalItem(update.key),
        ReturnValues: 'ALL_NEW',
        UpdateExpression: update.updateExpression.resolvedExpression,
    };
    if (conditionalExpression) {
        const expression = resolve_expression_1.resolveExpression(conditionalExpression.expression.stack);
        input.ConditionExpression = expression.resolvedExpression;
        input.ExpressionAttributeNames = helpers_1.mergeExpressionAttributeNames(expression.expressionAttributeNames, update.updateExpression.expressionAttributeNames);
        input.ExpressionAttributeValues = helpers_1.mergeExpressionAttributeValues(expression.expressionAttributeValues, update.updateExpression.expressionAttributeValues);
    }
    else {
        input.ExpressionAttributeNames = helpers_1.mergeExpressionAttributeNames(update.updateExpression.expressionAttributeNames);
        input.ExpressionAttributeValues = helpers_1.mergeExpressionAttributeValues(update.updateExpression.expressionAttributeValues);
    }
    return input;
}
exports.buildUpdateInput = buildUpdateInput;
