import ConditionExpression from './condition';
import MatchExpression from './match';
import NotExpression from './not';
import { BeginsWith, ComparisonOperator, Contains, IsBetween, IsEqualTo, IsGreaterOrEqualTo, IsGreaterThan, IsIn, IsLessOrEqualTo, IsLessThan, IsNotEqualTo, Operator } from './operator';
export declare function condition(expression: ConditionExpression | MatchExpression | NotExpression): ConditionExpression;
export declare function not(expression: ConditionExpression | MatchExpression | NotExpression): NotExpression;
export declare function match(operand: string, operator: Operator): MatchExpression;
export declare function attributeExists(attribute: string): MatchExpression;
export declare function attributeNotExists(attribute: string): MatchExpression;
export declare function size(attribute: string, operator: ComparisonOperator): MatchExpression;
export declare function beginsWith(subString: string): BeginsWith;
export declare function contains(operand: string): Contains;
export declare function isEqualTo(a: number | string | boolean): IsEqualTo;
export declare function isNotEqualTo(a: number | string | boolean): IsNotEqualTo;
export declare function isGreaterThan(a: number | string): IsGreaterThan;
export declare function isLessThan(a: number | string): IsLessThan;
export declare function isLessOrEqualTo(a: number | string): IsLessOrEqualTo;
export declare function isGreaterOrEqualTo(a: number | string): IsGreaterOrEqualTo;
export declare function isBetween(b: number, c: number): IsBetween;
export declare function isIn(values: string[]): IsIn;
