"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function resolveExpression(expressionStack) {
    return expressionStack.reduce((acc, expression) => {
        switch (expression.kind) {
            case 'condition': {
                acc.resolvedExpression +=
                    '(' + resolveExpression(expression.conditionStack) + ')';
                return acc;
            }
            case 'not': {
                acc.resolvedExpression +=
                    'NOT (' + resolveExpression(expression.notStack) + ')';
                return acc;
            }
            case 'and': {
                acc.resolvedExpression += ' and ';
                return acc;
            }
            case 'or': {
                acc.resolvedExpression += ' or ';
                return acc;
            }
            case 'match': {
                acc.resolvedExpression += expression.matchValue;
                acc.expressionAttributeValues = Object.assign({}, acc.expressionAttributeValues, expression.expressionAttributeValues);
                acc.expressionAttributeNames = Object.assign({}, acc.expressionAttributeNames, expression.expressionAttributeNames);
                return acc;
            }
        }
        return acc;
    }, {
        resolvedExpression: '',
        expressionAttributeValues: {},
        expressionAttributeNames: {},
    });
}
exports.resolveExpression = resolveExpression;
