"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const find_1 = require("../../chaining/find");
const dynamo_entity_1 = require("../dynamo-entity");
class DynamoIndexWithCompositeKey extends dynamo_entity_1.DynamoEntityWithCompositeKey {
    constructor(indexSchema) {
        super({
            tableName: indexSchema.tableName,
            indexSchema,
        });
    }
    find(args) {
        if (!args) {
            return new find_1.DynamoScan(this._entitySchema);
        }
        return new find_1.DynamoQuery({
            schema: this._entitySchema, partitionKey: args,
        });
    }
}
exports.DynamoIndexWithCompositeKey = DynamoIndexWithCompositeKey;
