"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dynamo_table_1 = require("../dynamo-table");
class DynamoORMWithSimpleKey extends dynamo_table_1.DynamoTableWithSimpleKey {
    constructor(tableSchema, globalIndexes, localIndexes, dynamoPromise) {
        super(tableSchema, dynamoPromise);
        this.globalIndexes = globalIndexes;
        this.localIndexes = localIndexes;
        this.onIndex = Object.assign({}, this.globalIndexes, this.localIndexes);
        this.injectTableNameOnIndexes();
        this.injectDynamoPromiseOnIndexes();
    }
    injectTableNameOnIndexes() {
        for (const index in this.onIndex) {
            if (this.onIndex.hasOwnProperty(index)) {
                this.onIndex[index]._entitySchema.tableName = this._entitySchema.tableName;
            }
        }
    }
    injectDynamoPromiseOnIndexes() {
        for (const index in this.onIndex) {
            if (this.onIndex.hasOwnProperty(index)) {
                this.onIndex[index]._entitySchema.dynamoPromise = this._entitySchema.dynamoPromise;
            }
        }
    }
}
exports.DynamoORMWithSimpleKey = DynamoORMWithSimpleKey;
