import { TableSchema } from '../';
import { DynamoBatchDelete, DynamoDelete } from '../../chaining/delete';
import { DynamoBatchGet, DynamoGet, DynamoQuery, DynamoScan } from '../../chaining/find';
import { DynamoBatchWrite, DynamoPut } from '../../chaining/save';
import { DynamoUpdate, ExplicitKeyItemType, ImplicityKeyItemType } from '../../chaining/update';
import DynamoPromise from '../../database-operations/dynamo-to-promise';
import { DynamoEntityWithCompositeKey } from '../dynamo-entity';
export declare class DynamoTableWithCompositeKey<Table, PartitionKey, SortKey> extends DynamoEntityWithCompositeKey<Table, PartitionKey, SortKey, PartitionKey & SortKey> {
    private mockData;
    constructor(tableSchema: TableSchema, dynamoPromise: DynamoPromise);
    find(): DynamoScan<Table, PartitionKey & SortKey>;
    find(keys: Array<PartitionKey & SortKey>): DynamoBatchGet<Table, PartitionKey & SortKey>;
    find(key: PartitionKey & SortKey): DynamoGet<Table, PartitionKey & SortKey>;
    find(partitionKey: PartitionKey): DynamoQuery<Table, PartitionKey, SortKey, PartitionKey & SortKey>;
    save(item: Table): DynamoPut<Table>;
    save(items: Table[]): DynamoBatchWrite<Table>;
    update(key: PartitionKey & SortKey, item: ExplicitKeyItemType<Table, PartitionKey & SortKey>): DynamoUpdate<Table, PartitionKey & SortKey>;
    update(item: ImplicityKeyItemType<Table, PartitionKey & SortKey>): DynamoUpdate<Table, PartitionKey & SortKey>;
    delete(key: PartitionKey & SortKey): DynamoDelete<Table, PartitionKey & SortKey>;
    delete(keys: Array<PartitionKey & SortKey>): DynamoBatchDelete<PartitionKey & SortKey>;
}
