import { TableSchema } from '../';
import { DynamoBatchDelete, DynamoDelete } from '../../chaining/delete';
import { DynamoBatchGet, DynamoGet, DynamoScan } from '../../chaining/find';
import { DynamoBatchWrite, DynamoPut } from '../../chaining/save';
import { DynamoUpdate, ExplicitKeyItemType, ImplicityKeyItemType } from '../../chaining/update';
import DynamoPromise from '../../database-operations/dynamo-to-promise';
import { DynamoEntityWithSimpleKey } from '../dynamo-entity';
export declare class DynamoTableWithSimpleKey<Table, PartitionKey> extends DynamoEntityWithSimpleKey<Table, PartitionKey, PartitionKey> {
    private mockData;
    constructor(tableSchema: TableSchema, dynamoPromise: DynamoPromise);
    find(): DynamoScan<Table, PartitionKey>;
    find(keys: PartitionKey[]): DynamoBatchGet<Table, PartitionKey>;
    find(key: PartitionKey): DynamoGet<Table, PartitionKey>;
    save(item: Table): DynamoPut<Table>;
    save(items: Table[]): DynamoBatchWrite<Table>;
    update(key: PartitionKey, item: ExplicitKeyItemType<Table, PartitionKey>): DynamoUpdate<Table, PartitionKey>;
    update(item: ImplicityKeyItemType<Table, PartitionKey>): DynamoUpdate<Table, PartitionKey>;
    delete(key: PartitionKey): DynamoDelete<Table, PartitionKey>;
    delete(keys: PartitionKey[]): DynamoBatchDelete<PartitionKey>;
}
