"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dynamo_index_1 = require("../../../../schema/dynamo-index");
const dynamo_orm_1 = require("../../../../schema/dynamo-orm");
class SimpleKeyWithGlobalIndex {
    constructor(dynamoPromise, tableSchema, currentGlobalIndexes, currentLocalIndexes) {
        this.dynamoPromise = dynamoPromise;
        this.tableSchema = tableSchema;
        this.currentGlobalIndexes = currentGlobalIndexes;
        this.currentLocalIndexes = currentLocalIndexes;
    }
    getInstance() {
        return new dynamo_orm_1.DynamoORMWithSimpleKey(this.tableSchema, this.currentGlobalIndexes, this.currentLocalIndexes, this.dynamoPromise);
    }
    withGlobalIndex(config) {
        if (config.sortKey) {
            this.currentGlobalIndexes = Object.assign({}, this.currentGlobalIndexes, { [config.indexName]: new dynamo_index_1.DynamoIndexWithCompositeKey(config) });
            return new SimpleKeyWithGlobalIndex(this.dynamoPromise, this.tableSchema, this.currentGlobalIndexes, this.currentLocalIndexes);
        }
        this.currentGlobalIndexes = Object.assign({}, this.currentGlobalIndexes, { [config.indexName]: new dynamo_index_1.DynamoIndexWithSimpleKey(config) });
        return new SimpleKeyWithGlobalIndex(this.dynamoPromise, this.tableSchema, this.currentGlobalIndexes, this.currentLocalIndexes);
    }
}
exports.SimpleKeyWithGlobalIndex = SimpleKeyWithGlobalIndex;
