import { TypeDynamoDefineTableCompositeKey, TypeDynamoDefineTableSimpleKey } from './define-table';
export interface SdkOptions {
    region: string;
    accessKeyId?: string;
    secretAccessKey?: string;
    credentials?: AWS.Credentials;
    credentialProvider?: AWS.CredentialProviderChain;
    apiVersion?: string;
    endpoint?: string;
    sslEnabled?: boolean;
    sessionToken?: string;
    maxRetries?: number;
    maxRedirects?: number;
    daxEndpoints?: string[];
}
export declare class TypeDynamo {
    private dynamoPromise;
    constructor(sdkOptions: SdkOptions);
    define<Table, PartitionKey extends keyof Table, SortKey extends keyof Table>(table: {
        new (): Table;
    }, schema: {
        tableName: string;
        partitionKey: PartitionKey;
        sortKey: SortKey;
    }): TypeDynamoDefineTableCompositeKey<Table, PartitionKey, SortKey>;
    define<Table, PartitionKey extends keyof Table>(table: {
        new (): Table;
    }, schema: {
        tableName: string;
        partitionKey: PartitionKey;
    }): TypeDynamoDefineTableSimpleKey<Table, PartitionKey>;
}
