"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const aws_sdk_1 = require("aws-sdk");
const dynamo_to_promise_1 = require("../../database-operations/dynamo-to-promise");
const define_table_1 = require("./define-table");
const AmazonDaxClient = require('amazon-dax-client');
class TypeDynamo {
    constructor(sdkOptions) {
        this.dynamoPromise = new dynamo_to_promise_1.default(new aws_sdk_1.DynamoDB.DocumentClient({
            accessKeyId: sdkOptions.accessKeyId,
            secretAccessKey: sdkOptions.secretAccessKey,
            apiVersion: sdkOptions.apiVersion,
            credentials: sdkOptions.credentials,
            credentialProvider: sdkOptions.credentialProvider,
            endpoint: sdkOptions.endpoint,
            region: sdkOptions.region,
            sslEnabled: sdkOptions.sslEnabled,
            sessionToken: sdkOptions.sessionToken,
            maxRetries: sdkOptions.maxRetries,
            maxRedirects: sdkOptions.maxRedirects,
            service: sdkOptions.daxEndpoints &&
                AmazonDaxClient({ endpoints: sdkOptions.daxEndpoints, region: sdkOptions.region }),
        }));
    }
    define(table, schema) {
        if (schema.sortKey !== undefined) {
            return new define_table_1.TypeDynamoDefineTableCompositeKey(this.dynamoPromise, schema);
        }
        return new define_table_1.TypeDynamoDefineTableSimpleKey(this.dynamoPromise, schema);
    }
}
exports.TypeDynamo = TypeDynamo;
